<?php

if (!class_exists('System')) exit; // Запрет прямого доступа



$ChatStorage = new EngineStorage('module.chat');


function bbcode($html){
	return '<pre><code>'.trim($html[1]).'</code></pre>';
}


function ptext($text){
	$text = preg_replace_callback('#\[code\](.*?)\[/code\]#si', 'bbcode', $text);
	$text = preg_replace('#\[b\](.*?)\[/b\]#si', '<span style="font-weight: bold;">\1</span>', $text);
	$text = preg_replace('#\[red\](.*?)\[/red\]#si', '<span style="color: #E53935;">\1</span>', $text);
	$text = str_replace("\n",'<br>',$text);
	$text = specfilter($text);
	return $text;
}

/*

// Обработка ajax
if(isset($URI[3]) && isset($URI[4])){
	if($URI[3] == 'ajax'){
		header("Cache-Control: no-store, no-cache, must-revalidate");// не даем кешировать ajax тупым браузерам (IE)
		switch ($URI[4]) {
			
			case 'newcommentcheck':
				if($newsStorage->iss('count_'.$URI[2])){
					echo $newsStorage->get('count_'.$URI[2]);
				}else{
					echo 0;
				}
				break;
			
			case 'addcomment':
				if (md5($_POST['ticket'].$Config->ticketSalt) != $_COOKIE['ticket']){
					echo'Ticket';
				}elseif($User->authorized){
					
					if($newsConfig->commentRules > 1 && $User->preferences == 0){
						// ошибка если нехватает префов
						echo'Error';
					}else{
						// Обрабатываем форму от авторизированных
						
						if($newsStorage->iss('news_'.$URI[2])){
							
								// Обрабатываем форму от пользователя
								$textForm = trim(htmlspecialchars($_POST['text']));
								
								if(mb_strlen($textForm, 'utf-8') <= $newsConfig->commentMaxLength && mb_strlen($textForm, 'utf-8') > 0){
									
									
									$idComment = $newsStorage->iss('idComment')?$newsStorage->get('idComment'):0;
									++$idComment;
									$newsStorage->set('idComment', $idComment);
									
									
									if($newsConfig->commentModeration == 0){$published = 1;}
									elseif($newsConfig->commentModeration == 1){$published = ($User->numPost >= $newsConfig->commentModerationNumPost)?1:0;}
									elseif($newsConfig->commentModeration == 2){$published = ($User->preferences > 0)?1:0;}
									else{$published = 0;}
									
									if ($published){
										$arrayComments = json_decode($newsStorage->get('comments_'.$URI[2]), true);
										$arrayComments[] = array(
													'id' => $idComment,
													'login' => $User->login,
													'text' => $textForm,
													'ip' => IP,
													'status' => 'user',
													'time' => time());
										
										$arrayCount = count($arrayComments);
										if($arrayCount >= $newsConfig->commentMaxCount){
											$arrayStart = $arrayCount -  round($newsConfig->commentMaxCount / 1.5);
											$arrayComments = array_slice($arrayComments, $arrayStart, $arrayCount);
										}
										
										if($newsStorage->set('comments_'.$URI[2], json_encode($arrayComments))){
											
											++$User->numPost;
											$User->save();
											
											$count = $newsStorage->iss('count_'.$URI[2])?$newsStorage->get('count_'.$URI[2]):0;
											++$count;
											$newsStorage->set('count_'.$URI[2], $count);
											
											echo $count;
											
										}else{
											echo'Error';
										}
										unset($arrayComments);
										
									}else{
										echo'Moderation';
									}
									
									
									
									
									
									
									// в список последних 
									$lastComments = json_decode($newsStorage->get('lastComments'), true);
									$lastComments[] = array(
												'idComment' => $idComment,
												'idNews' => $URI[2],
												'login' => $User->login,
												'text' => $textForm,
												'ip' => IP,
												'status' => 'user',
												'published' => $published,
												'time' => time());
									$newsStorage->set('lastComments', json_encode($lastComments));
									
									
								}else{
									echo'Error';
								}
							
						}else{
							echo'Error';
						}
					}
				}else{
					if($newsStorage->iss('news_'.$URI[2])){
						if($newsConfig->commentRules > 0){
							// ошибка необходимости авторизироваться
							echo'Error';
						}else{
							// Обрабатываем форму от гостей
							$loginForm = htmlspecialchars(specfilter($_POST['login']));
							$textForm = trim(htmlspecialchars($_POST['text']));
							
							if (md5(strtolower($_POST['captcha']).$Config->ticketSalt) != $_COOKIE['captcha']){
								echo'Captcha';
							}elseif(System::validPath($loginForm) && mb_strlen($loginForm, 'utf-8') < 36 && mb_strlen($textForm, 'utf-8') <= $newsConfig->commentMaxLength && mb_strlen($textForm, 'utf-8') > 0){
								if (User::exists($loginForm)){
									echo'Exists';
								}else{
									
									
									$idComment = $newsStorage->iss('idComment')?$newsStorage->get('idComment'):0;
									++$idComment;
									$newsStorage->set('idComment', $idComment);
									
									
									
									$published = ($newsConfig->commentModeration == 0)?1:0;
									
									
									if ($published){
										$arrayComments = json_decode($newsStorage->get('comments_'.$URI[2]), true);
										$arrayComments[] = array(
													'id' => $idComment,
													'login' => $loginForm,
													'text' => $textForm,
													'ip' => IP,
													'status' => 'gost',
													'time' => time());
										
										$arrayCount = count($arrayComments);
										if($arrayCount >= $newsConfig->commentMaxCount){
											$arrayStart = $arrayCount -  round($newsConfig->commentMaxCount / 1.5);
											$arrayComments = array_slice($arrayComments, $arrayStart, $arrayCount);
										}
										
										if($newsStorage->set('comments_'.$URI[2], json_encode($arrayComments))){
											
											$count = $newsStorage->iss('count_'.$URI[2])?$newsStorage->get('count_'.$URI[2]):0;
											++$count;
											$newsStorage->set('count_'.$URI[2], $count);
											echo $count;
											
										}else{
											echo'Error';
										}
										unset($arrayComments);
										
									}else{
										echo'Moderation';
									}
									
									
									// в список последних 
									$lastComments = json_decode($newsStorage->get('lastComments'), true);
									$lastComments[] = array(
												'idComment' => $idComment,
												'idNews' => $URI[2],
												'login' => $loginForm,
												'text' => $textForm,
												'ip' => IP,
												'status' => 'gost',
												'published' => $published,
												'time' => time());
									$newsStorage->set('lastComments', json_encode($lastComments));
									
								}
							}else{
								echo'Error';
							}
							setcookie('captcha','',time(),'/');// Обнулили куки
						}
					}else{
						echo'Error';
					}
				}
				break;
				
			case 'validlogin':
				if (System::validPath($_POST['login'])){
					if (User::exists($_POST['login'])){
						echo $_POST['login'].' уже существует';
					}
				}else{
					echo 'Недопустимые символы';
				}
				break;
			
			
			
			case 'dellcomments':
				if (md5($_POST['ticket'].$Config->ticketSalt) != $_COOKIE['ticket']){
					echo'Ticket';
				}elseif($newsStorage->iss('news_'.$URI[2]) && ($User->preferences > 0 || $status == 'admin')){
					$arrayComments = json_decode($newsStorage->get('comments_'.$URI[2]), true);
					$count = 0;
					
					// foreach($_POST['comment'] as $value){
						// if(isset($arrayComments[$value])){
							// unset($arrayComments[$value]);
							// ++$count;
						// }
					// }
					
					foreach($arrayComments as $i => $row){
						if (in_array($row['id'], $_POST['comment'])){
							unset($arrayComments[$i]);
							++$count;
						}
					}
					
					if($count > 0){
						// Переиндексировали числовые индексы 
						$arrayComments = array_values($arrayComments); 
						// сохраняем массив комментов
						if($newsStorage->set('comments_'.$URI[2], json_encode($arrayComments))){
							echo $count;
						}else{ echo'Error'; }
					}else{ echo'Error'; }
				}else{ echo'Error'; }
				break;
			
			case 'loadcomments':
				if (is_numeric($URI[5]) && $URI[5] >= 0){
					if($newsStorage->iss('comments_'.$URI[2])){
						$arrayComments = json_decode($newsStorage->get('comments_'.$URI[2]), true);
						
						for($i = count($arrayComments) - $URI[5] - 1, $x = $i - $newsConfig->commentNavigation, $count = 0; $i >= $x; --$i){
							if($i < 0) break;
							echo'<div class="comment" id="comment'.$arrayComments[$i]['id'].'">
								<div class="commentHead">
									<a href="/'.$newsConfig->idUser.'/'.$arrayComments[$i]['login'].'" class="author">'.$arrayComments[$i]['login'].'</a>
									'.($arrayComments[$i]['status'] == 'gost'?'<span class="gost">Гость</span>':'').'
									<span class="time">'.human_time(time() - $arrayComments[$i]['time']).' назад</span>
									'.($newsConfig->commentRules == 0 || $User->authorized ? '<a href="javascript:void(0);"  onClick="Comments.toUser(\''.$arrayComments[$i]['login'].'\')" class="re">Ответить</a>':'').'
									'.($User->preferences > 0 || $status == 'admin' ? '<input type="checkbox" onClick="Comments.commentDellCheck();" name="comment[]" value="'.$arrayComments[$i]['id'].'">':'').'
									
								</div>
								<div class="commentContent">'.ptext($arrayComments[$i]['text']).'</div>
							</div>';
							++$count;
						}
						if ($x > 0){
							echo'<button type="button" id="loadCommentsButton" onclick="Comments.loadComments('.($URI[5] + $newsConfig->commentNavigation + 1).');">Загрузить ещё</button>';
						}
						if ($count == 0){
							echo'<div class="noComments">Нет ни одного комментария</div>';
						}
						
					}else{
						echo'<div class="noComments">Нет ни одного комментария</div>';
					}
				}else{
					echo 'Ошибка при загрузки сообщений';
				}
				break;
				
			default :
				echo'Error';
				break;
		}
		 ob_end_flush(); exit;
	}
}


*/








// Встраивание в страницу




if(isset($URI[2])){
	// Обработка ajax
	if($URI[2] == 'ajax' && isset($URI[3])){
		header("Cache-Control: no-store, no-cache, must-revalidate");// не даем кешировать ajax тупым браузерам (IE)
		switch ($URI[3]) {
			case 'newcheck':
				if($ChatStorage->iss('idMessage')){
					echo $ChatStorage->get('idMessage');
				}else{
					echo 0;
				}
				break;
			
			case 'loadchat':
				if($ChatStorage->iss('messages')){
					$arrayMessages = json_decode($ChatStorage->get('messages'), true);
					if(isset($URI[4])){
						if(is_numeric($URI[4])){
							foreach($arrayMessages as $row){
								if($URI[4] < $row['id']){
									echo'<div class="post" id="id'.$row['id'].'"><div class="head">
<a href="javascript:void(0);" class="user" onClick="Chat.toUser(\''.$row['login'].'\')" class="re">'.$row['login'].'</a>
<spam class="time">'.date("d.m.y H:i", $row['time']).'</spam> '.($User->preferences > 0 || $status == 'admin' ? '<input type="checkbox" onClick="Chat.dellCheck();" name="checkedpost[]" value="'.$row['id'].'">':'').'
</div><div class="msg">'.ptext($row['message']).'</div></div>';
								}
							}
						}
					}
// 					foreach($arrayMessages as $row){

// echo'<div class="post"><div class="head">
// <a href="javascript:void(0);" class="user" onClick="Chat.toUser(\''.$row['login'].'\')" class="re">'.$row['login'].'</a>
// <spam class="time">'.date("d.m.y H:i", $row['time']).'</spam> 
// </div><div class="msg">'.ptext($row['message']).'</div></div>';

// 					}
				}
				break;

			case 'add':
				if (md5($_POST['ticket'].$Config->ticketSalt) != $_COOKIE['ticketChat']){
					echo'Ticket'; // 
				}elseif($User->authorized){
					
					// Обрабатываем форму от пользователя
					$message = trim(htmlspecialchars($_POST['msg']));
					
					if(mb_strlen($message, 'utf-8') <= 1000 && mb_strlen($message, 'utf-8') > 0){
						
						$idMessage = $ChatStorage->iss('idMessage')?$ChatStorage->get('idMessage'):0;
						++$idMessage;
						$ChatStorage->set('idMessage', $idMessage);
						
						$arrayMessages = json_decode($ChatStorage->get('messages'), true);
						$arrayMessages[] = array(
									'id' => $idMessage,
									'login' => $User->login,
									'message' => $message,
									'ip' => IP,
									'time' => time());
						
						$arrayCount = count($arrayMessages);
						if($arrayCount >= 200){
							$arrayStart = $arrayCount -  round(200 / 1.5);
							$arrayMessages = array_slice($arrayMessages, $arrayStart, $arrayCount);
						}
						
						if($ChatStorage->set('messages', json_encode($arrayMessages))){
							
							++$User->numPost;
							$User->save();
							
							echo $idMessage;
							
						}else{
							echo'Error';
						}
						unset($arrayMessages);
					}else{
						echo'Error';
					}
				}
				
				break;

			case 'dell':
				if (md5($_POST['ticket'].$Config->ticketSalt) != $_COOKIE['ticketChat']){
					echo'Error'; // Ticket
				}elseif($ChatStorage->iss('messages') && ($User->preferences > 0 || $status == 'admin')){
					$arrayMessages = json_decode($ChatStorage->get('messages'), true);
					$count = 0;
					
					foreach($arrayMessages as $i => $row){
						if (in_array($row['id'], $_POST['checkedpost'])){
							unset($arrayMessages[$i]);
							++$count;
						}
					}

					if($count > 0){
						// Переиндексировали числовые индексы 
						$arrayMessages = array_values($arrayMessages); 
						// сохраняем массив комментов
						if($ChatStorage->set('messages', json_encode($arrayMessages))){
							echo $count;
						}else{ echo'Error'; }
					}else{ echo'Error'; }
				}else{ echo'Error'; }
				
				break;

			default :
				echo'Error';
				break;
		}
		ob_end_flush(); exit();
	}

	
}else{

	$ticket = random(255);
	setcookie('ticketChat',md5($ticket.$Config->ticketSalt),time()+32000000,'/');


?><!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<?php $page->get_headhtml();?>
<title><?php $page->get_title();?></title>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
<meta name="description" content="<?php $page->get_description();?>">
<meta name="keywords" content="<?php $page->get_keywords();?>">
<script type="text/javascript"><?php echo file_get_contents('modules/'.$page->module.'/jloader/jloader.min.js');?></script>
<script type="text/javascript"><?php echo file_get_contents('modules/'.$page->module.'/chat.min.js');?></script>
<style type="text/css"><?php echo file_get_contents('modules/'.$page->module.'/style.css');?></style>
</head>
<body>
<div id="chat">
<h1 id="header"><?php $page->get_name();?></h1>
<?php if($User->authorized):?>
<img src="/modules/chat/down.svg" alt="" id="down" onclick="Chat.down();" title="Вниз">
<button type="button" id="dellButton" onclick="Chat.dell();">Удалить выделенное</button>
<a href="/user" id="user"><?php echo $User->login;?></a>
<div id="posts"></div>
<div id="form">
	<form name="form" action="#" method="post" onsubmit="Chat.submit(); return false;">
		<input type="hidden" name="ticket" value="<?php echo $ticket;?>">
		<textarea id="msg" name="msg" placeholder="Сообщение..." rows="1" onkeypress="if(event.keyCode==10||(event.ctrlKey && event.keyCode==13)){Chat.submit();}" required></textarea>
	</form>
	<img src="/modules/chat/send.svg" alt="" id="send" onclick="Chat.submit();" title="Отправить">
</div>
</div>
<script type="text/javascript">
	Chat.run({
		id: "<?php echo $URI[1];?>",
		ticket: "<?php echo $ticket;?>",
		checkInterval: 15000,
		maxLength: 1000
	});

	// Убираем шапку если открыто в iframe
	if (window!=window.top) {
		document.getElementById('header').style.display = 'none';
		if(document.getElementById('header')){
			document.getElementById('user').style.display = 'none';
		}
	}
</script>
<?php else:?>
<a href="/user" id="user">Вход</a>
<div id="errorAut">Для общения в нашем чате необходимо <a href="/user">авторизироваться</a> или <a href="/user">зарегистрироваться</a></div>
<?php endif;?>
</body></html><?php

	ob_end_flush(); exit();

}

return false;
?>